#!/usr/bin/python

## code is made by Pim Muilwijk
## adjustment for Domoticz by Albert @ Hakvoort (dot) co
## version 0.3

import datetime, socket, requests

## Domoticz Settings ##

domoticzip = "127.0.0.1"
domoticzport = "8080"

# IDX of Dummy devices

outsideairtemp = 20 
supplyairtemp = 21
returnairtemp = 22
exhaustairtemp = 23
returnairlevel = 99
supplyairlevel = 98 
fanlevel = 100


class Ventilation:
    def __init__(self):
        self.outsideAirTemp = False
        self.supplyAirTemp  = False
        self.returnAirTemp  = False
        self.exhaustAirTemp = False
        self.returnAirLevel = False
        self.supplyAirLevel = False
        self.fanLevel       = False
        self.lowTime        = False
        self.mediumTime     = False
        self.highTime       = False
        self.filterTime     = False
        self.lastUpdated    = datetime.datetime.now()

    def GetVentilationData(self):
#        print '{0}: 05-Starting GetVentilationData...'.format(datetime.datetime.now())
        
        ventilationSocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        ventilationSocket.connect(('127.0.0.1', 7788))
        ventilationSocket.sendall('Ventilation||GetData')
        ventilationData = ventilationSocket.recv(128)
        ventilationSocket.close()

        ventilationData = ventilationData.split('|')

        if ventilationData[0] != 'False':
            self.lastUpdated     = datetime.datetime.fromtimestamp(float(ventilationData[0]))
        else:
            self.lastUpdated     = False

        if ventilationData[1] != 'False':
            self.outsideAirTemp  = float(ventilationData[1])
        else:
            self.outsideAirTemp  = False

        if ventilationData[2] != 'False':
            self.supplyAirTemp   = float(ventilationData[2])
        else:
            self.supplyAirTemp   = False

        if ventilationData[3] != 'False':
            self.returnAirTemp   = float(ventilationData[3])
        else:
            self.returnAirTemp   = False

        if ventilationData[4] != 'False':
            self.exhaustAirTemp  = float(ventilationData[4])
        else:
            self.exhaustAirTemp  = False

        if ventilationData[5] != 'False':
            self.returnAirLevel  = int(ventilationData[5])
        else:
            self.returnAirLevel  = False

        if ventilationData[6] != 'False':
            self.supplyAirLevel  = int(ventilationData[6])
        else:
            self.supplyAirLevel  = False

        if ventilationData[7] != 'False':
            self.fanLevel        = int(ventilationData[7])
        else:
            self.fanLevel        = False

        if ventilationData[8] != 'False':
            self.lowTime         = int(ventilationData[8])
        else:
            self.lowTime         = False

        if ventilationData[9] != 'False':
            self.mediumTime      = int(ventilationData[9])
        else:
            self.mediumTime      = False

        if ventilationData[10] != 'False':
            self.highTime        = int(ventilationData[10])
        else:
            self.highTime        = False

        if ventilationData[11] != 'False':
            self.filterTime      = int(ventilationData[11])
        else:
            self.filterTime      = False

#        print '{0}: 05-Finished GetVentilationData.'.format(datetime.datetime.now())


Ventilation = Ventilation()
Ventilation.GetVentilationData()

#print Ventilation.lowTime       
#print Ventilation.mediumTime    
#print Ventilation.highTime      
#print Ventilation.filterTime    

if Ventilation.outsideAirTemp == False:
	print "No outsideAirTemp Data"
else:
 	print "outsideyAirTemp = %s" % Ventilation.outsideAirTemp	
	url = "http://%s:%s/json.htm?type=command&param=udevice&idx=%s&nvalue=0&svalue=%s" % (domoticzip, domoticzport, outsideairtemp, Ventilation.outsideAirTemp)
	r = requests.get(url) 
	r.json()

if Ventilation.supplyAirTemp == False:
	print "No supplyAirTemp Data"
else:
 	print "supplyAirTemp = %s" % Ventilation.supplyAirTemp	
	url = "http://%s:%s/json.htm?type=command&param=udevice&idx=%s&nvalue=0&svalue=%s" % (domoticzip, domoticzport, supplyairtemp, Ventilation.supplyAirTemp)
	r = requests.get(url) 
	r.json()

if Ventilation.returnAirTemp == False:
	print "No returnAir Data"
else:
 	print "returnAirTemp = %s" % Ventilation.returnAirTemp	
	url = "http://%s:%s/json.htm?type=command&param=udevice&idx=%s&nvalue=0&svalue=%s" % (domoticzip, domoticzport, returnairtemp, Ventilation.returnAirTemp)
	r = requests.get(url) 
	r.json()

if Ventilation.exhaustAirTemp == False:
	print "No exhaustAir Data"
else:
 	print "exhaustAirTemp = %s" % Ventilation.exhaustAirTemp	
	url = "http://%s:%s/json.htm?type=command&param=udevice&idx=%s&nvalue=0&svalue=%s" % (domoticzip, domoticzport, exhaustairtemp, Ventilation.exhaustAirTemp)
	r = requests.get(url) 
	r.json()

if Ventilation.returnAirLevel == False:
	print "No returnAirlevel Data"
else:
	print "returnAirLevel = %s" % Ventilation.returnAirLevel
	url = "http://%s:%s/json.htm?type=command&param=udevice&idx=%s&nvalue=0&svalue=%s" % (domoticzip, domoticzport, returnairlevel, Ventilation.returnAirLevel)
	r = requests.get(url) 
	r.json()

if Ventilation.supplyAirLevel == False:
	print "No supplyAirlevel Data"
else: 
	print "SupplyAirlevel = %s" % Ventilation.supplyAirLevel
	url = "http://%s:%s/json.htm?type=command&param=udevice&idx=%s&nvalue=0&svalue=%s" % (domoticzip, domoticzport, supplyairlevel, Ventilation.supplyAirLevel)
	r = requests.get(url) 
	r.json()

if Ventilation.fanLevel == False:
	print "FanLevel = Unknown"
else:
	print "fanLevel = %s" % Ventilation.fanLevel
	url = "http://%s:%s/json.htm?type=command&param=udevice&idx=%s&nvalue=0&svalue=%s" % (domoticzip, domoticzport, fanlevel, Ventilation.fanLevel)
	r = requests.get(url) 
	r.json()
